import { ArgumentsError } from './errors/ArgumentsError';
import { EvaluationError } from './errors/EvaluationError';
import { InternalError } from './errors/InternalError';
import { ParsingError } from './errors/ParsingError';
import { TimeoutError } from './errors/TimeoutError';
import { Action, ModelInput, Options, PatternFactory } from './Interfaces';
export { ArgumentsError, EvaluationError, InternalError, ParsingError, TimeoutError, };
/** @type {HapifySyntax} Syntax parser */
export declare class HapifySyntax implements PatternFactory {
    template: string;
    private model;
    private options;
    /** Stores the original input */
    private original;
    actions: Action[];
    private patterns;
    /** Constructor */
    constructor(template: string, model: ModelInput, options?: Partial<Options>);
    /** Parser method */
    static run(template: string, model: ModelInput, options?: Partial<Options>): string;
    /** Execute all patterns to convert hpf to js */
    private parse;
    /** Eval the generated script */
    private evaluate;
    /** Reverse all action to find the error line and column in the input file */
    private getReversedActionError;
    /** Cleanup generated code */
    private postProcess;
}
