"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotesInterpolationPattern = void 0;
const BasePattern_1 = require("./BasePattern");
/** Notes interpolation pattern */
const RegEx = new RegExp(`<<!\\s*([a-zA-Z_.]+)\\s*>>`, 'g');
/** NotesInterpolation pattern */
class NotesInterpolationPattern extends BasePattern_1.BasePattern {
    /** Parser method */
    execute() {
        this.replace(RegEx, (match, variable) => {
            // Get the var
            let jsVariable = variable;
            if (['M', 'Model'].includes(jsVariable))
                jsVariable = 'root';
            else if (['P', 'PrimaryField'].includes(jsVariable))
                jsVariable = 'root.fields.primary';
            return `\${${jsVariable}.notes}`;
        });
    }
}
exports.NotesInterpolationPattern = NotesInterpolationPattern;
//# sourceMappingURL=NotesInterpolationPattern.js.map